From e5b2efd38107a2570d29d4bcc3609a64a82494e4 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Wed, 7 Aug 2019 10:56:13 -0400
Subject: [PATCH 16/31] better support for the various ways to join a squad,
 and the various ways to leave a squad; squad-based messages; jury-rigged
 'player wants to join' operations

---
 .../game/SquadDefinitionActionMessage.scala   |  48 +-
 .../packet/game/SquadMemberEvent.scala        |  60 +-
 .../services/teamwork/SquadResponse.scala     |   4 +
 .../services/teamwork/SquadService.scala      | 702 ++++++++++++------
 .../SquadDefinitionActionMessageTest.scala    |  20 +-
 .../scala/game/SquadMemberEventTest.scala     |   4 +-
 .../src/main/scala/WorldSessionActor.scala    | 174 +++--
 7 files changed, 681 insertions(+), 331 deletions(-)

diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 32bbc68e..11a56ee2 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -16,9 +16,26 @@ import shapeless.{::, HNil}
 abstract class SquadAction(val code : Int)
 
 object SquadAction{
+  object SearchMode extends Enumeration {
+    type Type = Value
+
+    val
+    AnyPositions,
+    AvailablePositions,
+    SomeCertifications,
+    AllCertifications
+    = Value
+
+    implicit val codec : Codec[SearchMode.Value] = PacketHelpers.createEnumerationCodec(enum = this, uint(bits = 3))
+  }
+
   final case class DisplaySquad() extends SquadAction(0)
 
-  final case class AnswerSquadJoinRequest() extends SquadAction(1)
+  /**
+    * Dispatched from client to server to indicate a squad detail update that has no foundation entry to update?
+    * Not dissimilar from `DisplaySquad`.
+    */
+  final case class DisplayFullSquad() extends SquadAction(1)
 
   final case class SaveSquadFavorite() extends SquadAction(3)
 
@@ -58,12 +75,14 @@ object SquadAction{
 
   final case class LocationFollowsSquadLead(state : Boolean) extends SquadAction(31)
 
-  final case class SearchForSquadsWithParticularRole(u1: String, u2 : Long, u3: Int, u4 : Int) extends SquadAction(34)
+  final case class SearchForSquadsWithParticularRole(role: String, requirements : Set[CertificationType.Value], zone_id: Int, mode : SearchMode.Value) extends SquadAction(34)
 
   final case class CancelSquadSearch() extends SquadAction(35)
 
   final case class AssignSquadMemberToRole(position : Int, char_id : Long) extends SquadAction(38)
 
+  final case class NoSquadSearchResults() extends SquadAction(39)
+
   final case class FindLfsSoldiersForRole(state : Int) extends SquadAction(40)
 
   final case class CancelFind() extends SquadAction(41)
@@ -91,10 +110,10 @@ object SquadAction{
       }
     )
 
-    val answerSquadJoinRequestCodec = everFailCondition.xmap[AnswerSquadJoinRequest] (
-      _ => AnswerSquadJoinRequest(),
+    val displayFullSquadCodec = everFailCondition.xmap[DisplayFullSquad] (
+      _ => DisplayFullSquad(),
       {
-        case AnswerSquadJoinRequest() => None
+        case DisplayFullSquad() => None
       }
     )
 
@@ -243,12 +262,12 @@ object SquadAction{
       PacketHelpers.encodedWideStringAligned(6) ::
         ulongL(46) ::
         uint16L ::
-        uintL(3)).xmap[SearchForSquadsWithParticularRole] (
+        SearchMode.codec).xmap[SearchForSquadsWithParticularRole] (
       {
-        case u1 :: u2 :: u3 :: u4 :: HNil => SearchForSquadsWithParticularRole(u1, u2, u3, u4)
+        case u1 :: u2 :: u3 :: u4 :: HNil => SearchForSquadsWithParticularRole(u1, CertificationType.fromEncodedLong(u2), u3, u4)
       },
       {
-        case SearchForSquadsWithParticularRole(u1, u2, u3, u4) => u1 :: u2 :: u3 :: u4 :: HNil
+        case SearchForSquadsWithParticularRole(u1, u2, u3, u4) => u1 :: CertificationType.toEncodedLong(u2) :: u3 :: u4 :: HNil
       }
     )
 
@@ -268,6 +287,13 @@ object SquadAction{
       }
     )
 
+    val noSquadSearchResultsCodec = everFailCondition.xmap[NoSquadSearchResults] (
+      _ => NoSquadSearchResults(),
+      {
+        case NoSquadSearchResults() => None
+      }
+    )
+
     val findLfsSoldiersForRoleCodec = uint4.xmap[FindLfsSoldiersForRole] (
       state => FindLfsSoldiersForRole(state),
       {
@@ -326,6 +352,7 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`18` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`26` - Reset All<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`35` - Cancel Squad Search<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`39` - No Squad Search Results<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`41` - Cancel Find<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`42` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`43` - UNKNOWN<br>
@@ -388,7 +415,7 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
     import scala.annotation.switch
     ((code : @switch) match {
       case 0 => displaySquadCodec
-      case 1 => answerSquadJoinRequestCodec
+      case 1 => displayFullSquadCodec
       case 3 => saveSquadFavoriteCodec
       case 4 => loadSquadFavoriteCodec
       case 5 => deleteSquadFavoriteCodec
@@ -411,12 +438,13 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 34 => searchForSquadsWithParticularRoleCodec
       case 35 => cancelSquadSearchCodec
       case 38 => assignSquadMemberToRoleCodec
+      case 39 => noSquadSearchResultsCodec
       case 40 => findLfsSoldiersForRoleCodec
       case 41 => cancelFindCodec
       case 2 | 6 | 11 |
            12 | 13 | 14 | 16 |
            18 | 29 | 30 | 32 | 33 |
-           36 | 37 | 39 | 42 | 43 => unknownCodec(code)
+           36 | 37 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
     }).asInstanceOf[Codec[SquadAction]]
   }
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala b/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
index 503254a5..51b74955 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
@@ -12,18 +12,18 @@ object MemberEvent extends Enumeration {
   val
   Add,
   Remove,
-  Unknown2,
+  Promote,
   UpdateZone,
   Unknown4
     = Value
 
-  implicit val codec = PacketHelpers.createEnumerationCodec(this, uint(3))
+  implicit val codec = PacketHelpers.createEnumerationCodec(enum = this, uint(bits = 3))
 }
 
-final case class SquadMemberEvent(unk1 : Int,
+final case class SquadMemberEvent(action : MemberEvent.Value,
                                   unk2 : Int,
                                   char_id : Long,
-                                  member_position : Int,
+                                  position : Int,
                                   player_name : Option[String],
                                   zone_number : Option[Int],
                                   unk7 : Option[Long])
@@ -34,40 +34,46 @@ final case class SquadMemberEvent(unk1 : Int,
 }
 
 object SquadMemberEvent extends Marshallable[SquadMemberEvent] {
-  def apply(unk1 : Int, unk2 : Int, char_id : Long, member_position : Int) : SquadMemberEvent =
-    SquadMemberEvent(unk1, unk2, char_id, member_position, None, None, None)
+  def apply(action : MemberEvent.Value, unk2 : Int, char_id : Long, position : Int) : SquadMemberEvent =
+    SquadMemberEvent(action, unk2, char_id, position, None, None, None)
 
-  def apply(unk2 : Int, char_id : Long, member_position : Int, player_name : String, zone_number : Int, unk7 : Long) : SquadMemberEvent =
-    SquadMemberEvent(0, unk2, char_id, member_position, Some(player_name), Some(zone_number), Some(unk7))
+  def Add(unk2 : Int, char_id : Long, position : Int, player_name : String, zone_number : Int, unk7 : Long) : SquadMemberEvent =
+    SquadMemberEvent(MemberEvent.Add, unk2, char_id, position, Some(player_name), Some(zone_number), Some(unk7))
 
-  def apply(unk2 : Int, char_id : Long, member_position : Int, zone_number : Int) : SquadMemberEvent =
-    SquadMemberEvent(3, unk2, char_id, member_position, None, Some(zone_number), None)
+  def Remove(unk2 : Int, char_id : Long, position : Int) : SquadMemberEvent =
+    SquadMemberEvent(MemberEvent.Remove, unk2, char_id, position, None, None, None)
 
-  def apply(unk2 : Int, char_id : Long, member_position : Int, unk7 : Long) : SquadMemberEvent =
-    SquadMemberEvent(4, unk2, char_id, member_position, None, None, Some(unk7))
+  def Promote(unk2 : Int, char_id : Long) : SquadMemberEvent =
+    SquadMemberEvent(MemberEvent.Promote, unk2, char_id, 0, None, None, None)
+
+  def UpdateZone(unk2 : Int, char_id : Long, position : Int, zone_number : Int) : SquadMemberEvent =
+    SquadMemberEvent(MemberEvent.UpdateZone, unk2, char_id, position, None, Some(zone_number), None)
+
+  def Unknown4(unk2 : Int, char_id : Long, position : Int, unk7 : Long) : SquadMemberEvent =
+    SquadMemberEvent(MemberEvent.Unknown4, unk2, char_id, position, None, None, Some(unk7))
 
   implicit val codec : Codec[SquadMemberEvent] = (
-    ("unk1" | uint(3)) >>:~ { unk1 =>
+    ("action" | MemberEvent.codec) >>:~ { action =>
       ("unk2" | uint16L) ::
         ("char_id" | uint32L) ::
-        ("member_position" | uint4) ::
-        conditional(unk1 == 0, "player_name" | PacketHelpers.encodedWideStringAligned(1)) ::
-        conditional(unk1 == 0 || unk1 == 3, "zone_number" | uint16L) ::
-        conditional(unk1 == 0 || unk1 == 4, "unk7" | uint32L)
+        ("position" | uint4) ::
+        conditional(action == MemberEvent.Add, "player_name" | PacketHelpers.encodedWideStringAligned(1)) ::
+        conditional(action == MemberEvent.Add || action == MemberEvent.UpdateZone, "zone_number" | uint16L) ::
+        conditional(action == MemberEvent.Add || action == MemberEvent.Unknown4, "unk7" | uint32L)
     }).exmap[SquadMemberEvent] (
     {
-      case unk1 :: unk2 :: char_id :: member_position :: player_name :: zone_number :: unk7 :: HNil =>
-        Attempt.Successful(SquadMemberEvent(unk1, unk2, char_id, member_position, player_name, zone_number, unk7))
+      case action :: unk2 :: char_id :: member_position :: player_name :: zone_number :: unk7 :: HNil =>
+        Attempt.Successful(SquadMemberEvent(action, unk2, char_id, member_position, player_name, zone_number, unk7))
     },
     {
-      case data @ SquadMemberEvent(0, unk2, char_id, member_position, Some(player_name), Some(zone_number), Some(unk7)) =>
-        Attempt.Successful(0 :: unk2 :: char_id :: member_position :: Some(player_name) :: Some(zone_number) :: Some(unk7) :: HNil)
-      case data @ SquadMemberEvent(3, unk2, char_id, member_position, None, Some(zone_number), None) =>
-        Attempt.Successful(3 :: unk2 :: char_id :: member_position :: None :: Some(zone_number) :: None :: HNil)
-      case data @ SquadMemberEvent(4, unk2, char_id, member_position, None, None, Some(unk7)) =>
-        Attempt.Successful(4 :: unk2 :: char_id :: member_position :: None :: None :: Some(unk7) :: HNil)
-      case data @ SquadMemberEvent(unk1, unk2, char_id, member_position, None, None, None) =>
-        Attempt.Successful(unk1 :: unk2 :: char_id :: member_position :: None :: None :: None :: HNil)
+      case SquadMemberEvent(MemberEvent.Add, unk2, char_id, member_position, Some(player_name), Some(zone_number), Some(unk7)) =>
+        Attempt.Successful(MemberEvent.Add :: unk2 :: char_id :: member_position :: Some(player_name) :: Some(zone_number) :: Some(unk7) :: HNil)
+      case SquadMemberEvent(MemberEvent.UpdateZone, unk2, char_id, member_position, None, Some(zone_number), None) =>
+        Attempt.Successful(MemberEvent.UpdateZone :: unk2 :: char_id :: member_position :: None :: Some(zone_number) :: None :: HNil)
+      case SquadMemberEvent(MemberEvent.Unknown4, unk2, char_id, member_position, None, None, Some(unk7)) =>
+        Attempt.Successful(MemberEvent.Unknown4 :: unk2 :: char_id :: member_position :: None :: None :: Some(unk7) :: HNil)
+      case SquadMemberEvent(action, unk2, char_id, member_position, None, None, None) =>
+        Attempt.Successful(action :: unk2 :: char_id :: member_position :: None :: None :: None :: HNil)
       case data =>
         Attempt.Failure(Err(s"SquadMemberEvent can not encode with this pattern - $data"))
     }
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index 26215f02..562082ae 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -18,10 +18,14 @@ object SquadResponse {
   final case class Unknown17(squad : Squad, char_id : Long) extends Response
   final case class Membership(request_type : SquadResponseType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
   final case class Invite(from_char_id : Long, to_char_id : Long, name : String) extends Response
+  final case class WantsSquadPosition(bid_name : String) extends Response
   final case class Join(squad : Squad, positionsToUpdate : List[Int]) extends Response
   final case class Leave(squad : Squad, positionsToUpdate : List[(Long, Int)]) extends Response
   final case class UpdateMembers(squad : Squad, update_info : List[SquadAction.Update]) extends Response
   final case class AssignMember(squad : Squad, from_index : Int, to_index : Int) extends Response
+  final case class PromoteMember(squad : Squad, char_id : Long, from_index : Int, to_index : Int) extends Response
 
   final case class Detail(guid : PlanetSideGUID, squad_detail : SquadDetail) extends Response
+
+  final case class SquadSearchResults() extends Response
 }
